.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     PushButton.inc
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName       db "WndClass",0
ButtonClassName db "Button",0
AppName         db "Window with push button",0
ButtonText      db "Test",0

.data?
hInstance HINSTANCE ?

.code

start:

    invoke  GetModuleHandle,0
    mov     hInstance,eax
    invoke  GetCommandLine
    invoke  WinMain,hInstance,NULL,eax,SW_SHOWDEFAULT
    invoke  ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

    LOCAL   wc:WNDCLASSEX
    LOCAL   msg:MSG
    LOCAL   hwnd:HWND
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInstance
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW+1
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx, addr wc
    invoke  CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
            WS_OVERLAPPEDWINDOW or WS_VISIBLE,\
            CW_USEDEFAULT,CW_USEDEFAULT,400,250,\
            NULL,NULL,hInst,NULL
    mov     hwnd,eax
    invoke  UpdateWindow,hwnd

    .WHILE TRUE
        invoke  GetMessage, ADDR msg,NULL,0,0
        .BREAK  .IF (!eax)
        invoke  TranslateMessage, ADDR msg
        invoke  DispatchMessage, ADDR msg
    .ENDW

    mov     eax,msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_CREATE
        invoke  CreateWindowEx,WS_EX_WINDOWEDGE,ADDR ButtonClassName,ADDR ButtonText,\
                WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON,\
                150,75,100,75,hWnd,
                NULL,hInstance,NULL

    .ELSEIF uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL

    .ELSE
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam        
        ret

    .ENDIF

    xor eax,eax
    ret

WndProc ENDP

END start
